unit TradCol;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls,StructureDonnees, Grids, ExtCtrls, StdCtrls,
  ColorStringGrid, Mask, rxToolEdit, Buttons;

type
  TCoupleTrad = record
    ATraduire:string[255];
    Traduction:string[255];
  end;
  TTraduct_Col = class(TForm)
    PageControl1: TPageControl;
    Taxons: TTabSheet;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrer1: TMenuItem;
    OpenDialog: TOpenDialog;
    Quitter1: TMenuItem;
    N1: TMenuItem;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Panel1: TPanel;
    BComplete: TButton;
    CarObs: TTabSheet;
    CarTab: TTabSheet;
    Panel2: TPanel;
    Splitter3: TSplitter;
    GridTaxons: TColorStringGrid;
    GridNomFicTax: TColorStringGrid;
    Panel4: TPanel;
    TabCat: TColorStringGrid;
    Panel5: TPanel;
    TabCarObs: TColorStringGrid;
    TCPH: TTabSheet;
    TableauCph: TColorStringGrid;
    TabDocs: TTabSheet;
    Panel3: TPanel;
    TableauDocs: TColorStringGrid;
    PanNomCol: TPanel;
    OKCol: TBitBtn;
    Panel6: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    RepTrad: TDirectoryEdit;
    Panel7: TPanel;
    RepOrg: TEdit;
    Panel8: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Panel9: TPanel;
    NomOrg: TEdit;
    NomTrad: TEdit;
    TabCarTab: TColorStringGrid;
    Splitter4: TSplitter;
    TabEtats: TColorStringGrid;
    Splitter5: TSplitter;
    Panel10: TPanel;
    CompleteCarTab: TButton;
    Splitter6: TSplitter;
    TabGroupes: TColorStringGrid;
    Panel11: TPanel;
    ValidCPH: TButton;
    ValidTaxons: TButton;
    Splitter7: TSplitter;
    Panel12: TPanel;
    Panel13: TPanel;
    Label5: TLabel;
    TOrg: TEdit;
    Label6: TLabel;
    TMod: TEdit;
    BRemplacer: TButton;
    BValidDocs: TButton;
    BValidCarTab: TButton;
    Panel14: TPanel;
    BValidCarObs: TButton;
    BcompleteDocs: TButton;
    VerifRemp: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Panel16: TPanel;
    RempO: TEdit;
    RempT: TEdit;
    Bverif: TButton;
    RemplirCT: TButton;
    Panel15: TPanel;
    Label9: TLabel;
    OpenLex: TOpenDialog;
    OuvrirLexique: TMenuItem;
    N2: TMenuItem;
    SaveDialogLex: TSaveDialog;
    procedure Ouvrir1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure BCompleteClick(Sender: TObject);
    procedure ColorGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure OKColClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure ValidCPHClick(Sender: TObject);
    procedure ValidTaxonsClick(Sender: TObject);
    procedure CompleteCarTabClick(Sender: TObject);
    procedure BValidCarTabClick(Sender: TObject);
    procedure BValidCarObsClick(Sender: TObject);
    procedure BValidDocsClick(Sender: TObject);
    procedure BRemplacerClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BcompleteDocsClick(Sender: TObject);
    procedure BverifClick(Sender: TObject);
    procedure RemplirCTClick(Sender: TObject);
    procedure OuvrirLexiqueClick(Sender: TObject);

  private
    { Dclarations prives }
    SousCollections:Array of TSousCollection;
    SousCollectionsT:Array of TSousCollection;
    RepCol:string;
    RepColTrad:string;
    RepCph:string;
    RepCphTrad:string;
    FicsCph:TStringList;
    NssCol:integer;
    CaseRouge:TAffichCoul;
    CaseJaune:TAffichCoul;
    CaseVerte:TAffichCoul;
    CaseBlanche:TAffichCoul;
    Active:boolean;
    CouleurFond:TColor;
    CouleurTexte:TColor;
    styleFond:TBrushStyle;
    CouleurContour:TColor;
    ListeDocs:TStringList;
    ListeSE:TStringList;
    AEnregistrer:Boolean;
    FichierLexique:string;
    Lexique:TStringList;
    Modifs:TStringList;
    procedure RemplitTaxons;
    procedure RemplitCph;
    procedure RemplitCarObs;
    procedure RemplitCarTab;
    Procedure ChangeTaxons;
    procedure ChangeCarObs;
    procedure ChangeCarTab;
    procedure ChangeCph;
    procedure RemplitDocs;
    procedure ChangeDocs;
    procedure Enregistre;
    Procedure RenomeFichiersTax;
    procedure AdapteLargeur(Tableau:TStringGrid);
    procedure ElimineBlancs(Tableau:TStringGrid;col:integer);
    procedure RemplacerMajMin(AncChaine,NouvChaine:string;var Chaine:string);
    Function CoupleTrad(Chaine:string):TCoupleTrad;
    Function TraductionDe(Liste:TStringList;Chaine:string):string;
    Procedure VerifieTrad(Tableau:TColorStringGrid);
    Procedure ModifieTrad(Tableau:TColorStringGrid);
    Procedure CompleteLexique(Tableau:TColorStringGrid);
    Function IndiceDe(Chaine:string;Liste:TStringList):integer;
    Procedure EnregistreLexique;
  public
    { Dclarations publiques }

  end;

var
  Traduct_Col: TTraduct_Col;

implementation
uses utils;
{$R *.dfm}

procedure TTraduct_Col.Enregistre;
begin
  ChangeTaxons;
  ChangeCarObs;
  ChangeCarTab;
  ChangeDocs;
  ChangeCph;
  if FichierLexique<>'' then
    begin
      if MessageDlg('Voulez-vous remplacer le fichier lexique par celui complt avec ce travail ?',
        mtConfirmation,[mbYes,mbNo],0)=mrYes then
        begin
          EnregistreLexique;
          AEnregistrer:=False;
        end;
    end;
  if AEnregistrer then
    begin
      if MessageDlg('Voulez-vous enregistrer un nouveau fichier lexique ?',
        mtConfirmation,[mbYes,mbNo],0)=mrYes then
        begin
          if SaveDialogLex.Execute then
            begin
              FichierLexique:=ExpandFileName(SaveDialogLex.FileName);
              EnregistreLexique;
            end;
        end;
    end;

  AEnregistrer:=False;
  PageControl1.Visible:=False;
  PanNomCol.Visible:=False;
end;
procedure TTraduct_Col.Ouvrir1Click(Sender: TObject);
Var
  LaCollection:TSousCollection;
  LaCollectionT:TSousCollection;
  i:integer;
  Extensions:TStringList;
  UneListe:TStringList;
  RepImagesTax:string;
  RepImagesDocs:string;
  RepIconesTax:string;
  RepText,chaine:string;
begin
  If OpenDialog.Execute then
    begin
      SetLength(SousCollections,0);
      RepCph:=ExtractFileDir(ExpandFileName(OpenDialog.FileName));
      RepCol:=GetDossierParent(RepCph)+'\';
      RepImagesTax:=RepCol+'Taxons\';
      RepImagesDocs:=RepCol+'Carac-Images\';
      RepIconesTax:=RepCol+'Icones\';
      RepText:=RepCol+'Carac-Textes\';
      FicsCph.Clear;
      UneListe:=TStringList.Create;
      UneListe.LoadFromFile(RepCol+'Nom.txt');
      NomOrg.Text:=UneListe[0];
      NomTrad.Text:=UneListe[0];
      UneListe.Free;
      chaine:=GetDossierParent(RepCph);
      RepTrad.Text:=GetDossierParent(chaine)+'\';
      Extensions:=TStringList.Create;
      Extensions.Add('.cph');
      if recherche_fichiers(RepCph,Extensions,FicsCph) then
        begin
          For i:=0 to FicsCph.Count-1 do
            begin
              FicsCph[i]:=ExpandFileName(FicsCph[i]+'.cph');
              LaCollection:=TSousCollection.Create;
              SetLength(SousCollections,Length(SousCollections)+1);
              SousCollections[Length(SousCollections)-1]:=LaCollection;
              LaCollectionT:=TSousCollection.Create;
              SetLength(SousCollectionsT,Length(SousCollectionsT)+1);
              SousCollectionsT[Length(SousCollectionsT)-1]:=LaCollectionT;
              LaCollection.LitCph(FicsCph[i]);
              RepOrg.Text:=LaCollection.DossierCollection;
              LaCollectionT.LitCph(FicsCph[i]);
              LaCollection.Taxons.CheminImagesT:=RepImagesTax;
              LaCollection.Taxons.CheminIconesT:=RepIconesTax;
              LaCollection.Caracteres.CheminImagesC:=RepImagesDocs;
              LaCollection.Caracteres.CheminTextesC:=RepText;
            end;
        end;
      Extensions.Free;
      RemplitCph;
      RemplitTaxons;
      RemplitCarObs;
      RemplitCarTab;
      PanNomCol.Visible:=True;
      PageControl1.Visible:=False;
      AEnregistrer:=True;
    end;
end;

Procedure TTraduct_Col.RenomeFichiersTax;
Var
  i,j:integer;
  LeTaxon:TTaxon;
  LeTaxonT:TTaxon;
  collection:TSousCollection;
  collectionT:TSousCollection;
  Modifier:Boolean;
begin
  For j:=0 to Length(SousCollectionsT)-1 do
    begin
      Collection:=SousCollections[j];
      CollectionT:=SousCollectionsT[j];
      For i:=1 to Collection.Taxons.NbTaxons do
        begin
          if FileExists(Collection.Taxons.GetImage(i-1)) then
            RenameFile(Collection.Taxons.GetImage(i-1),CollectionT.Taxons.GetImage(i-1));
          if FileExists(Collection.Taxons.GetIcone(i-1)) then
            RenameFile(Collection.Taxons.GetIcone(i-1),CollectionT.Taxons.GetIcone(i-1));
        end;
    end;
end;
Procedure TTraduct_Col.ChangeTaxons;
Var
  i,j,k,n,lig:integer;
  LeTaxon:TTaxon;
  collection:TSousCollection;
  collectionT:TSousCollection;
  Modifier:Boolean;
  RepImagesTax:string;
  RepIconesTax:string;
  RepImagesDocs:string;
begin
  RepImagesTax:=RepColTrad+'Taxons\';
  RepIconesTax:=RepColTrad+'Icones\';
  RepImagesDocs:=RepColTrad+'Carac-Images\';
  ElimineBlancs(GridTaxons,1);
  ElimineBlancs(GridNomFicTax,1);
  For j:=0 to Length(SousCollectionsT)-1 do
    begin
      Collection:=SousCollections[j];
      CollectionT:=SousCollectionsT[j];
      For i:=1 to Collection.Taxons.NbTaxons do
        begin
          LeTaxon:=Collection.Taxons[i-1];
          Modifier:=False;
          For k:=1 to GridTaxons.RowCount-1 do
            begin
              if lowercase(LeTaxon.Nom)=lowercase(GridTaxons.Cells[0,k]) then
                begin
                  Modifier:=True;
                  n:=k;
                  Break;
                end;
            end;
          If Modifier then
            begin
              LeTaxon:=CollectionT.Taxons[i-1];
              if GridTaxons.Cells[1,n]<>'' then
                LeTaxon.Nom:=GridTaxons.Cells[1,n];
              lig:=CollectionT.TabRef.IndexOfRow(GridTaxons.Cells[0,n]);
              if lig>-1 then
                CollectionT.TabRef.StrItems[lig,0]:=GridTaxons.Cells[1,n];
              if (GridNomFicTax.Cells[1,n]<>'')and (GridNomFicTax.Cells[1,n]<>GridNomFicTax.Cells[0,n]) then
                begin
                  LeTaxon.Image:=GridNomFicTax.Cells[1,n];
                  RenameFile(RepImagesTax+GridNomFicTax.Cells[0,n]+'.jpg',RepImagesTax+LeTaxon.Image+'.jpg');
                  RenameFile(RepIconesTax+'S_'+GridNomFicTax.Cells[0,n]+'.bmp',RepIconesTax+'S_'+LeTaxon.Image+'.bmp');
                end;
              if DirectoryExists(RepImagesDocs+GridNomFicTax.Cells[0,n]) then
                begin
                  if GridNomFicTax.Cells[1,n]<>'' then
                    begin
                      RemoveDir(RepImagesDocs+GridNomFicTax.Cells[0,n]);
                      CreateDir(RepImagesTax+LeTaxon.Image);
                    end;
                end
              else
                begin
                  if GridNomFicTax.Cells[1,n]<>'' then
                    CreateDir(RepImagesTax+LeTaxon.Image)
                  else
                    CreateDir(RepImagesDocs+GridNomFicTax.Cells[0,n]);
                end;
            end;
        end;
    end;
end;
procedure TTraduct_Col.RemplitTaxons;
Var
  i,j,k,n:integer;
  LeTaxon:TTaxon;
  collection:TSousCollection;
  Ajouter:Boolean;
begin
  GridTaxons.RowCount:=1;//Collection.Taxons.NbTaxons;
  GridTaxons.Cells[0,0]:='Nom';
  GridTaxons.Cells[1,0]:='Traduction';
  GridNomFicTax.RowCount:=1;//Collection.Taxons.NbTaxons;
  GridNomFicTax.Cells[0,0]:='Fichier';
  GridNomFicTax.Cells[1,0]:='Traduction';
  n:=1;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      For i:=1 to Collection.Taxons.NbTaxons do
        begin
          LeTaxon:=Collection.Taxons[i-1];
          Ajouter:=True;
          For k:=1 to GridTaxons.RowCount-1 do
            begin
              if lowercase(LeTaxon.Nom)=lowercase(GridTaxons.Cells[0,k]) then
                begin
                  Ajouter:=False;
                  Break;
                end;
            end;
          If Ajouter then
            begin
              inc(n);
              GridTaxons.RowCount:=n;
              GridNomFicTax.RowCount:=n;
              if n=2 then
                begin
                  GridTaxons.FixedRows:=1;
                  GridNomFicTax.FixedRows:=1;
                end;
              GridTaxons.Cells[0,n-1]:=LeTaxon.Nom;
              GridTaxons.AffichCell[1,n-1]:=CaseRouge;
              GridNomFicTax.Cells[0,n-1]:=LeTaxon.Image;
              if leTaxon.Image=''then
                GridNomFicTax.AffichCell[1,n-1]:=CaseBlanche
              else
                GridNomFicTax.AffichCell[1,n-1]:=CaseRouge;
            end;
        end;
    end;
  AdapteLargeur(GridTaxons);
  AdapteLargeur(GridNomFicTax);
end;
procedure TTraduct_Col.RemplitCph;
Var
  j,n:integer;
  collection:TSousCollection;
begin
  TableauCph.RowCount:=1;
  TableauCph.Cells[0,0]:='Cph';
  TableauCph.Cells[1,0]:='Noms/Fichiers';
  TableauCph.Cells[2,0]:='Traduction';
  n:=1;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      inc(n,2);
      TableauCph.RowCount:=n;
      TableauCph.RowCount:=n;
      if n=3 then
        TableauCph.FixedRows:=1;
      TableauCph.Cells[0,n-2]:='Fichier '+intToStr(j+1);
      TableauCph.Cells[0,n-1]:='Nom '+intToStr(j+1);
      TableauCph.Cells[1,n-2]:=ExtractFileName(FicsCph[j]);
      TableauCph.AffichCell[2,n-2]:=CaseRouge;
      TableauCph.Cells[1,n-1]:=collection.Nom;
      TableauCph.AffichCell[2,n-1]:=CaseRouge;
    end;
  AdapteLargeur(TableauCph);
end;
procedure TTraduct_Col.ChangeCph;
Var
  j,k,n:integer;
  collectionT:TSousCollection;
  NvFichier:string;
begin
  ElimineBlancs(TableauCph,2);
  For j:=0 to Length(SousCollectionsT)-1 do
    begin
      CollectionT:=SousCollectionsT[j];
      n:=1+j*2;
      NvFichier:=RepCphTrad+TableauCph.Cells[1,n];
      if TableauCph.Cells[2,n]<>'' then
        begin
          NvFichier:=RepCphTrad+TableauCph.Cells[2,n];
          RenameFile(RepCphTrad+TableauCph.Cells[1,n],NvFichier);
        end
      else
        TableauCph.Cells[2,n]:=ExtractFileName(FicsCph[j]);
      if TableauCph.Cells[2,n+1]<>'' then
        collectionT.Nom:=TableauCph.Cells[2,n+1]
      else
        collectionT.Nom:=TableauCph.Cells[1,n+1];
      collectionT.EnregistreCph(True,collectionT.Nom,NvFichier);
    end;
end;
procedure TTraduct_Col.FormCreate(Sender: TObject);
begin
  FicsCph:=TStringList.Create;
  ListeDocs:=TStringList.Create;
  ListeSE:=TStringList.Create;
  Lexique:=TStringList.Create;
  Modifs:=TStringList.Create;
  Lexique.CaseSensitive:=False;
  Modifs.CaseSensitive:=False;
  Modifs.Sorted:=True;
  Lexique.Sorted:=False;
  CaseRouge.Active:=True;
  CaseRouge.CouleurTexte:=clBlack;
  CaseRouge.styleFond:=bsSolid;
  CaseRouge.CouleurFond:=clRed;
  CaseJaune:=CaseRouge;
  CaseJaune.CouleurFond:=clYellow;
  CaseVerte:=CaseRouge;
  CaseVerte.CouleurFond:=clLime;
  CaseBlanche:=CaseRouge;
  CaseBlanche.CouleurFond:=clWhite;
  CaseBlanche.Active:=False;
  AEnregistrer:=False;
end;

procedure TTraduct_Col.Quitter1Click(Sender: TObject);
begin
  Close;
end;

procedure TTraduct_Col.BCompleteClick(Sender: TObject);
Var
  i:integer;
begin
  For i:=1 to GridTaxons.RowCount-1 do
    begin
      if GridTaxons.Cells[1,i]='' then
        begin
          GridTaxons.Cells[1,i]:=GridTaxons.Cells[0,i];
          GridTaxons.AffichCell[1,i]:=CaseJaune;
        end;
      if GridNomFicTax.Cells[1,i]='' then
        begin
          GridNomFicTax.Cells[1,i]:=GridNomFicTax.Cells[0,i];
          GridNomFicTax.AffichCell[1,i]:=CaseJaune;
        end;
    end;
  AdapteLargeur(GridTaxons);
  AdapteLargeur(GridNomFicTax);
end;
procedure TTraduct_Col.AdapteLargeur(Tableau:TStringGrid);
Var
  i,j,n:integer;
begin
  For j:=0 to Tableau.ColCount-1 do
    begin
      n:=0;
      For i:=0 to Tableau.RowCount-1 do
        begin
          if Tableau.Canvas.TextWidth(Tableau.Cells[j,i])>n then
            n:=Tableau.Canvas.TextWidth(Tableau.Cells[j,i]);
        end;
      n:=n+5;
      Tableau.ColWidths[j]:=n;
    end;
end;
procedure TTraduct_Col.ElimineBlancs(Tableau:TStringGrid;col:integer);
Var
  i:integer;
begin
  For i:=1 to Tableau.RowCount-1 do
    Tableau.Cells[col,i]:=trim(Tableau.Cells[col,i]);
end;
procedure TTraduct_Col.ColorGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
Var
  ColorGrid:TColorStringGrid;
begin
  ColorGrid:=(Sender as TColorStringGrid);
  if ColorGrid<>Nil then
    ColorGrid.AffichCell[ACol,ARow]:=CaseBlanche;
end;

procedure TTraduct_Col.RemplitCarObs;
Var
  i,j,k,n:integer;
  LesCaracteres:TCaracteres;
  collection:TSousCollection;
  Ajouter:Boolean;
begin
  TabCat.RowCount:=1;//Collection.Taxons.NbTaxons;
  TabCat.Cells[0,0]:='Nom';
  TabCat.Cells[1,0]:='Traduction';
  n:=1;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      LesCaracteres:=Collection.Caracteres;
      For i:=1 to LesCaracteres.TypeCaract.Count do
        begin
          Ajouter:=True;
          For k:=1 to TabCat.RowCount-1 do
            begin
              if lowercase(LesCaracteres.TypeCaract[i-1])=lowercase(TabCat.Cells[0,k]) then
                begin
                  Ajouter:=False;
                  Break;
                end;
            end;
          If Ajouter then
            begin
              inc(n);
              TabCat.RowCount:=n;
              if n=2 then
                begin
                  TabCat.FixedRows:=1;
                end;
              TabCat.Cells[0,n-1]:=LesCaracteres.TypeCaract[i-1];
              TabCat.AffichCell[1,n-1]:=CaseRouge;
            end;
        end;
    end;
  AdapteLargeur(TabCat);
  TabCarObs.RowCount:=1;
  TabCarObs.Cells[0,0]:='Nom';
  TabCarObs.Cells[1,0]:='Traduction';
  n:=1;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      LesCaracteres:=Collection.Caracteres;
      For i:=1 to LesCaracteres.Noms.Count do
        begin
          Ajouter:=True;
          For k:=1 to TabCarObs.RowCount-1 do
            begin
              if lowercase(LesCaracteres.Noms[i-1])=lowercase(TabCarObs.Cells[0,k]) then
                begin
                  Ajouter:=False;
                  Break;
                end;
            end;
          If Ajouter then
            begin
              inc(n);
              TabCarObs.RowCount:=n;
              if n=2 then
                begin
                  TabCarObs.FixedRows:=1;
                end;
              TabCarObs.Cells[0,n-1]:=LesCaracteres.Noms[i-1];
              TabCarObs.AffichCell[1,n-1]:=CaseRouge;
            end;
        end;
    end;
  AdapteLargeur(TabCarObs);
end;
procedure TTraduct_Col.ChangeCarObs;
Var
  i,j,k,n:integer;
  LesCaracteres,LesCaracteresT:TCaracteres;
  collection,collectionT:TSousCollection;
  Modifier:Boolean;
begin
  ElimineBlancs(TabCat,1);
  ElimineBlancs(TabCarObs,1);
  n:=0;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      CollectionT:=SousCollectionsT[j];
      LesCaracteres:=Collection.Caracteres;
      LesCaracteresT:=CollectionT.Caracteres;
      For i:=1 to LesCaracteres.TypeCaract.Count do
        begin
          Modifier:=False;
          For k:=1 to TabCat.RowCount-1 do
            begin
              if lowercase(LesCaracteres.TypeCaract[i-1])=lowercase(TabCat.Cells[0,k]) then
                begin
                  Modifier:=True;
                  n:=k;
                  Break;
                end;
            end;
          If Modifier and (TabCat.Cells[1,n]<>'') then
            begin
              LesCaracteresT.TypeCaract[i-1]:=TabCat.Cells[1,n];
            end;
        end;
    end;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      CollectionT:=SousCollectionsT[j];
      LesCaracteres:=Collection.Caracteres;
      LesCaracteresT:=CollectionT.Caracteres;
      For i:=1 to LesCaracteres.Noms.Count do
        begin
          Modifier:=False;
          For k:=1 to TabCarObs.RowCount-1 do
            begin
              if lowercase(LesCaracteres.Noms[i-1])=lowercase(TabCarObs.Cells[0,k]) then
                begin
                  Modifier:=True;
                  n:=k;
                  Break;
                end;
            end;
          If Modifier and (TabCarObs.Cells[1,n]<>'') then
            begin
              LesCaracteresT.Noms[i-1]:=TabCarObs.Cells[1,n];
              For k:=0 to LesCaracteresT.CarDs.GetNbCarD-1 do
                begin
                  if LesCaracteresT.CarDs.Items[k].NomCarParent=TabCarObs.Cells[0,n] then
                    LesCaracteresT.CarDs.Items[k].NomCarParent:=TabCarObs.Cells[1,n];
                end;
            end;
        end;
    end;
end;

procedure TTraduct_Col.RemplitCarTab;
Var
  i,j,k,l,n:integer;
  LesCaracteres:TCarDs;
  LesEtats:TStringList;
  LesGroupes:TStringList;
  collection:TSousCollection;
  Ajouter:Boolean;
begin
  TabCarTab.RowCount:=1;//Collection.Taxons.NbTaxons;
  TabCarTab.Cells[0,0]:='Nom';
  TabCarTab.Cells[1,0]:='Traduction';
  n:=1;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      LesCaracteres:=Collection.Caracteres.CarDs;
      For i:=1 to LesCaracteres.GetNbCarD do
        begin
          Ajouter:=True;
          For k:=1 to TabCarTab.RowCount-1 do
            begin
              if lowercase(LesCaracteres.Items[i-1].Nom)=lowercase(TabCarTab.Cells[0,k]) then
                begin
                  Ajouter:=False;
                  Break;
                end;
            end;
          If Ajouter then
            begin
              inc(n);
              TabCarTab.RowCount:=n;
              if n=2 then
                begin
                  TabCarTab.FixedRows:=1;
                end;
              TabCarTab.Cells[0,n-1]:=LesCaracteres.Items[i-1].Nom;
              TabCarTab.AffichCell[1,n-1]:=CaseRouge;
            end;
        end;
    end;
  AdapteLargeur(TabCarTab);
  TabEtats.RowCount:=1;
  TabEtats.Cells[0,0]:='Etats';
  TabEtats.Cells[1,0]:='Traduction';
  n:=1;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      LesCaracteres:=Collection.Caracteres.CarDs;
      For i:=1 to LesCaracteres.GetNbCarD do
        begin
          LesEtats:=LesCaracteres.GetEtats(i-1);
          For l:=1 to LesEtats.Count do
            begin
              if LesEtats[l-1]<>'?' then
                begin
                  Ajouter:=True;
                  For k:=1 to TabEtats.RowCount-1 do
                    begin
                      if lowercase(LesEtats[l-1])=lowercase(TabEtats.Cells[0,k]) then
                        begin
                          Ajouter:=False;
                          Break;
                        end;
                    end;
                  If Ajouter then
                    begin
                      inc(n);
                      TabEtats.RowCount:=n;
                      if n=2 then
                        begin
                          TabEtats.FixedRows:=1;
                        end;
                      TabEtats.Cells[0,n-1]:=LesEtats[l-1];
                      TabEtats.AffichCell[1,n-1]:=CaseRouge;
                    end;
                end;
            end;
        end;
    end;
  AdapteLargeur(TabEtats);
  TabGroupes.RowCount:=1;
  TabGroupes.Cells[0,0]:='Groupes';
  TabGroupes.Cells[1,0]:='Traduction';
  n:=1;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      LesCaracteres:=Collection.Caracteres.CarDs;
      For i:=1 to LesCaracteres.GetNbCarD do
        begin
          LesGroupes:=LesCaracteres.Items[i-1].NomsGroupes;
          For l:=1 to LesGroupes.Count do
            begin
              if LesGroupes[l-1]<>'' then
                begin
                  Ajouter:=True;
                  For k:=1 to TabGroupes.RowCount-1 do
                    begin
                      if lowercase(LesGroupes[l-1])=lowercase(TabGroupes.Cells[0,k]) then
                        begin
                          Ajouter:=False;
                          Break;
                        end;
                    end;
                  If Ajouter then
                    begin
                      inc(n);
                      TabGroupes.RowCount:=n;
                      if n=2 then
                        begin
                          TabGroupes.FixedRows:=1;
                        end;
                      TabGroupes.Cells[0,n-1]:=LesGroupes[l-1];
                      TabGroupes.AffichCell[1,n-1]:=CaseRouge;
                    end;
                end;
            end;
        end;
    end;
  AdapteLargeur(TabGroupes);
end;
procedure TTraduct_Col.ChangeCarTab;
Var
  i,j,k,l,n,col:integer;
  LesCaracteres:TCarDs;
  LesEtats:TStringList;
  LesGroupes:TStringList;
  collection:TSousCollection;
  LesCaracteresT:TCarDs;
  LesEtatsT:TStringList;
  LesGroupesT:TStringList;
  collectionT:TSousCollection;
  Modifier:Boolean;
begin
  ElimineBlancs(TabCarTab,1);
  ElimineBlancs(TabEtats,1);
  ElimineBlancs(TabGroupes,1);
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      LesCaracteres:=Collection.Caracteres.CarDs;
      CollectionT:=SousCollectionsT[j];
      LesCaracteresT:=CollectionT.Caracteres.CarDs;
      For i:=1 to LesCaracteres.GetNbCarD do
        begin
          Modifier:=False;
          For k:=1 to TabCarTab.RowCount-1 do
            begin
              if lowercase(LesCaracteres.Items[i-1].Nom)=lowercase(TabCarTab.Cells[0,k]) then
                begin
                  Modifier:=True;
                  n:=k;
                  Break;
                end;
            end;
          If Modifier then
            begin
              if TabCarTab.Cells[1,n]<>'' then
                LesCaracteresT.Items[i-1].Nom:=TabCarTab.Cells[1,n];
              col:=CollectionT.TabRef.IndexOfCol(TabCarTab.Cells[0,n]);
              if col>-1 then
                CollectionT.TabRef.StrItems[0,col]:=TabCarTab.Cells[1,n];
            end;
        end;
    end;

  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      LesCaracteres:=Collection.Caracteres.CarDs;
      CollectionT:=SousCollectionsT[j];
      LesCaracteresT:=CollectionT.Caracteres.CarDs;
      For i:=1 to LesCaracteres.GetNbCarD do
        begin
          LesEtats:=LesCaracteres.GetEtats(i-1);
          LesEtatsT:=LesCaracteresT.GetEtats(i-1);
          For l:=1 to LesEtats.Count do
            begin
              if LesEtats[l-1]<>'?' then
                begin
                  Modifier:=False;
                  For k:=1 to TabEtats.RowCount-1 do
                    begin
                      if lowercase(LesEtats[l-1])=lowercase(TabEtats.Cells[0,k]) then
                        begin
                          Modifier:=True;
                          n:=k;
                          Break;
                        end;
                    end;
                  If Modifier then
                    begin
                      if TabEtats.Cells[1,n]<>'' then
                        LesEtatsT[l-1]:=TabEtats.Cells[1,n];
                    end;
                end;
            end;
        end;
    end;
//changer aussi les tats dans TabRef
  For j:=0 to Length(SousCollections)-1 do
    begin
      CollectionT:=SousCollectionsT[j];
      For i:=1 to CollectionT.TabRef.RowCount-1 do
        For k:=1 to CollectionT.TabRef.ColCount[i]-1 do
          For l:=1 to TabEtats.RowCount-1 do
            begin
              if (CollectionT.TabRef.StrItems[i,k]=TabEtats.Cells[0,l]) and (trim(TabEtats.Cells[1,l])<>'') then
                CollectionT.TabRef.StrItems[i,k]:=TabEtats.Cells[1,l];
            end;
    end;
  For j:=0 to Length(SousCollections)-1 do
    begin
      Collection:=SousCollections[j];
      LesCaracteres:=Collection.Caracteres.CarDs;
      CollectionT:=SousCollectionsT[j];
      LesCaracteresT:=CollectionT.Caracteres.CarDs;
      For i:=1 to LesCaracteres.GetNbCarD do
        begin
          LesGroupes:=LesCaracteres.Items[i-1].NomsGroupes;
          LesGroupesT:=LesCaracteresT.Items[i-1].NomsGroupes;
          For l:=1 to LesGroupes.Count do
            begin
              if LesGroupes[l-1]<>'' then
                begin
                  Modifier:=False;
                  For k:=1 to TabGroupes.RowCount-1 do
                    begin
                      if lowercase(LesGroupes[l-1])=lowercase(TabGroupes.Cells[0,k]) then
                        begin
                          Modifier:=True;
                          n:=k;
                          Break;
                        end;
                    end;
                  If Modifier then
                    begin
                      if TabGroupes.Cells[1,n]<>'' then
                        LesGroupesT[l-1]:=TabGroupes.Cells[1,n];
                    end;
                end;
            end;
        end;
    end;
end;
procedure TTraduct_Col.RemplitDocs;
Var
  i,n:integer;
  Listep:TStringList;
  extensions:TStringList;
  Dossier,chaine :string;
begin
  Listep:=TStringList.Create;
  extensions:=TStringList.Create;
  Extensions.Add('.jpg');
  Dossier:=RepColTrad+'Carac-Images\';
  recherche_fichiers(Dossier,extensions,Listep);
  ListeDocs.AddStrings(Listep);
  For i:=0 to ListeDocs.Count-1 do
    ListeDocs[i]:=RepColTrad+'Carac-Images\'+ListeDocs[i]+'.jpg';
  extensions.Clear;
  Listep.Clear;
  Extensions.Add('.rtf');
  Dossier:=RepColTrad+'Carac-Textes\';
  recherche_fichiers(Dossier,extensions,Listep);
  For i:=0 to Listep.Count-1 do
    Listep[i]:=RepColTrad+'Carac-Textes\'+Listep[i]+'.rtf';
  ListeDocs.AddStrings(Listep);
  TableauDocs.RowCount:=1;//Collection.Taxons.NbTaxons;
  TableauDocs.Cells[0,0]:='Nom de fichier';
  TableauDocs.Cells[1,0]:='Traduction';
  n:=1;
  For i:=0 to ListeDocs.Count-1 do
    begin
      chaine:=NomSansExt(ExtractFileName(ListeDocs[i]));
      if ListeSE.IndexOf(chaine)=-1 then
        begin
          ListeSE.Add(chaine);
          inc(n);
          TableauDocs.RowCount:=n;
          if n=2 then
            begin
              TableauDocs.FixedRows:=1;
            end;
          TableauDocs.Cells[0,n-1]:=chaine;
          TableauDocs.Cells[1,n-1]:=chaine;
          TableauDocs.AffichCell[1,n-1]:=CaseRouge;
        end;
    end;
  AdapteLargeur(TableauDocs);
  Listep.Free;
  extensions.Free;
end;
procedure TTraduct_Col.ChangeDocs;
Var
  i,j,k,n,m:integer;
  Liste:TStringList;
  chaine,chaineT,nomFT,rep,nouv :string;  //,ext
  CollectionT:TSousCollection;
  LeCaractD:TCaractD;
  LeTaxon:TTaxon;
begin
  ElimineBlancs(TableauDocs,1);
  For i:=0 to ListeDocs.Count-1 do
    begin
      chaine:=NomSansExt(ExtractFileName(ListeDocs[i]));
      n:=ListeSE.IndexOf(chaine);
      if (n>-1)and (TableauDocs.Cells[1,n+1]<>'') then
        begin
          chaineT:=TableauDocs.Cells[1,n+1];
          //Ext:=ExtractFileExt(ListeDocs[i]);
          nouv:=ListeDocs[i];
          RemplacerMajMin(Chaine,ChaineT,nouv);
          RenameFile(ListeDocs[i],nouv);
          //changer aussi dans la nouvelle collection
          For j:=0 to Length(SousCollectionsT)-1 do
            begin
              CollectionT:=SousCollectionsT[j];
              for k:=0 to CollectionT.Caracteres.CarDs.GetNbCarD-1 do
                begin
                  LeCaractD:=CollectionT.Caracteres.CarDs.Items[k];
                  Liste:=LeCaractD.ListeDocEtats;
                  for m:=0 to Liste.Count-1 do
                    begin
                      if lowercase(Liste[m])=lowercase(chaine) then
                        Liste[m]:=ChaineT;
                    end;
                end;
              for k:=0 to CollectionT.Taxons.NbTaxons-1 do
                begin
                  LeTaxon:=TTaxon(CollectionT.Taxons.Items[k]);
                  if LeTaxon<>Nil then
                    begin
                      Liste:=LeTaxon.ImageCars;
                      for m:=0 to Liste.Count-1 do
                        begin
                          if lowercase(Liste[m])=lowercase(chaine) then
                            Liste[m]:=ChaineT;
                        end;
                    end;
                end;
            end;
        end;
    end;
end;
procedure TTraduct_Col.OKColClick(Sender: TObject);
Var
  LaCollectionT:TSousCollection;
  RepImagesTax:string;
  RepImagesDocs:string;
  RepIconesTax:string;
  RepText:string;
  RepSeul:string;
  RepSeulO:string;
  i:integer;
  UneListe:TStringList;
  chaine:string;
begin
  chaine:=RepTrad.Text;
  if chaine[length(chaine)]='\' then
    delete(chaine,Length(chaine),1);
  chaine:=LowerCase(ExtractFileName(chaine));
  if (chaine='collections')  then
    begin
      MessageDlg('Attention, vous avez choisi le rpertoire de base des collections',mtError,[mbOK],0);
      exit;
    end;
  chaine:=RepTrad.Text;
  if chaine[length(chaine)]<>'\' then
    RepColTrad:=RepTrad.Text+'\'
  else
    begin
      RepColTrad:=RepTrad.Text;
      delete(chaine,length(chaine),1);
      RepTrad.Text:=chaine;
    end;
  RepSeul:=ExtractFileName(RepTrad.Text);
  RepSeulO:=ExtractFileName(RepOrg.Text);
  RepCphTrad:=RepColTrad+'Fichiers-Images\';
  RepImagesTax:=RepColTrad+'Taxons\';
  RepImagesDocs:=RepColTrad+'Carac-Images\';
  RepIconesTax:=RepColTrad+'Icones\';
  RepText:=RepColTrad+'Carac-Textes\';
  CopieRep(RepCol,RepColTrad);

  UneListe:=TStringList.Create;
  UneListe.Add(NomTrad.Text);
  UneListe.SaveToFile(RepColTrad+'Nom.txt');
  UneListe.Free;
  RenameFile(RepColTrad+RepSeulO+'.jpg',RepColTrad+RepSeul+'.jpg');
  RenameFile(RepColTrad+'Icone-'+RepSeulO+'.bmp',RepColTrad+'Icone-'+RepSeul+'.bmp');
  For i:=0 to Length(SousCollectionsT)-1 do
    begin
      LaCollectionT:=SousCollectionsT[i];
      LaCollectionT.DossierCollection:=RepSeul;
      LaCollectionT.Taxons.CheminImagesT:=RepImagesTax;
      LaCollectionT.Taxons.CheminIconesT:=RepIconesTax;
      LaCollectionT.Caracteres.CheminImagesC:=RepImagesDocs;
      LaCollectionT.Caracteres.CheminTextesC:=RepText;
      if NomSansExt(ExtractFileName(FicsCph[i]))=SousCollections[i].DossierCollection then
        begin
          TableauCph.Cells[2,1+2*i]:=Repseul+'.cph';
          TableauCph.Cells[2,2+2*i]:=NomTrad.Text;
        end;
    end;
  if Length(SousCollectionsT)=1 then
    begin
      TCPH.Visible:=False;
      PageControl1.ActivePage:=Taxons;
      ChangeCph;
    end;
  RemplitDocs;
  PanNomCol.Visible:=False;
  PageControl1.Visible:=True;
end;

procedure TTraduct_Col.FormDestroy(Sender: TObject);
begin
  FicsCph.Free;
  ListeDocs.Free;
  ListeSE.Free;
end;

procedure TTraduct_Col.Enregistrer1Click(Sender: TObject);
begin
  Enregistre;
end;

procedure TTraduct_Col.ValidCPHClick(Sender: TObject);
begin
  ChangeCph;
end;

procedure TTraduct_Col.ValidTaxonsClick(Sender: TObject);
begin
  ChangeTaxons;
  ChangeCph;
end;

procedure TTraduct_Col.CompleteCarTabClick(Sender: TObject);
Var
  i:integer;
begin
  For i:=1 to TabCarTab.RowCount-1 do
    begin
      if TabCarTab.Cells[1,i]='' then
        begin
          TabCarTab.Cells[1,i]:=TabCarTab.Cells[0,i];
          TabCarTab.AffichCell[1,i]:=CaseJaune;
        end;
    end;
  For i:=1 to TabEtats.RowCount-1 do
    begin
      if TabEtats.Cells[1,i]='' then
        begin
          TabEtats.Cells[1,i]:=TabEtats.Cells[0,i];
          TabEtats.AffichCell[1,i]:=CaseJaune;
        end;
    end;
  For i:=1 to TabGroupes.RowCount-1 do
    begin
      if TabGroupes.Cells[1,i]='' then
        begin
          TabGroupes.Cells[1,i]:=TabGroupes.Cells[0,i];
          TabGroupes.AffichCell[1,i]:=CaseJaune;
        end;
    end;
end;

procedure TTraduct_Col.BValidCarTabClick(Sender: TObject);
begin
  ChangeCarTab;
  ChangeCph;
end;

procedure TTraduct_Col.BValidCarObsClick(Sender: TObject);
begin
  ChangeCarObs;
  ChangeCph;
end;

procedure TTraduct_Col.BValidDocsClick(Sender: TObject);
begin
  ChangeDocs;
  ChangeCph;
end;

procedure TTraduct_Col.BRemplacerClick(Sender: TObject);
Var
  Chaine:string;
  i,n:integer;
begin
  TOrg.Text:=trim(TOrg.Text);
  TMod.Text:=trim(TMod.Text);
  Chaine:=TMod.Text;
  n:=pos(' ',Chaine);
  while n>0 do
    begin
      Delete(Chaine,n,1);
      n:=pos(' ',Chaine);
    end;
  TMod.Text:=Chaine;
  if (TOrg.Text<>'') and (TMod.Text<>'') and (TOrg.Text<>TMod.Text)  then
    begin
      For i:=1 to TableauDocs.RowCount-1 do
        begin
          Chaine:=TableauDocs.Cells[1,i];
          n:=pos(LowerCase(TOrg.Text),LowerCase(Chaine));
          if n>0 then
            begin
              RemplacerMajMin(TOrg.Text,TMod.Text,Chaine);
              TableauDocs.Cells[1,i]:=Chaine;
              TableauDocs.AffichCell[1,i]:=CaseJaune;
            end;
        end;
    end;
  AdapteLargeur(TableauDocs);
end;

procedure TTraduct_Col.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if AEnregistrer then
    begin
      if MessageDlg('Voulez-vous enregistrer le travail ?',mtconfirmation,[mbYes,mbNo],0)=mrYes then
        begin
          Enregistre;
          Application.ProcessMessages;
        end;
    end;
end;

procedure TTraduct_Col.BcompleteDocsClick(Sender: TObject);
Var
  i:integer;
begin
  For i:=1 to TableauDocs.RowCount-1 do
    begin
      if TableauDocs.Cells[1,i]='' then
        begin
          TableauDocs.Cells[1,i]:=TableauDocs.Cells[0,i];
          TableauDocs.AffichCell[1,i]:=CaseJaune;
        end;
    end;
  AdapteLargeur(TableauDocs);
end;

procedure TTraduct_Col.BverifClick(Sender: TObject);
Var
  Chaine:string;
  i,n:integer;
begin
  VerifRemp.Visible:=True;
  TOrg.Text:=trim(TOrg.Text);
  TMod.Text:=trim(TMod.Text);
  Chaine:=TMod.Text;
  n:=pos(' ',Chaine);
  while n>0 do
    begin
      Delete(Chaine,n,1);
      n:=pos(' ',Chaine);
    end;
  TMod.Text:=Chaine;
  if (TOrg.Text<>'') and (TMod.Text<>'') and (TOrg.Text<>TMod.Text)  then
    begin
      For i:=1 to TableauDocs.RowCount-1 do
        begin
          Chaine:=TableauDocs.Cells[1,i];
          if pos(LowerCase(TOrg.Text),LowerCase(Chaine))>0 then
            begin
              RemplacerMajMin(TOrg.Text,TMod.Text,Chaine);
              RempT.Text:=Chaine;
              RempO.Text:=TableauDocs.Cells[1,i];
              if MessageDlg('Remplacer ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
                begin
                  TableauDocs.Cells[1,i]:=Chaine;
                  TableauDocs.AffichCell[1,i]:=CaseJaune;
                end;
            end;
        end;
    end;
  AdapteLargeur(TableauDocs);
  VerifRemp.Visible:=False;
end;

procedure TTraduct_Col.RemplirCTClick(Sender: TObject);
Var
  i,j:integer;
begin
  For i:=1 to TabCarObs.RowCount-1 do
    begin
      if trim(TabCarObs.Cells[1,i])<>'' then
        begin
          for j:=1 to TabCarTab.RowCount-1 do
            if trim(LowerCase(TabCarObs.Cells[0,i]))=trim(LowerCase(TabCarTab.Cells[0,j])) then
              begin
                TabCarTab.Cells[1,j]:=trim(TabCarObs.Cells[1,i]);
              end;
        end;
    end;
end;
Procedure TTraduct_Col.RemplacerMajMin(AncChaine,NouvChaine:string;var Chaine:string);
Var
  l,p:integer;
begin
  l:=Length(AncChaine);
  p:=pos(LowerCase(AncChaine),LowerCase(Chaine));
  if p>0 then
    begin
      Delete(Chaine,p,l);
      Insert(NouvChaine,Chaine,p);
    end;
end;

procedure TTraduct_Col.OuvrirLexiqueClick(Sender: TObject);
Var
  i,n:integer;
  Tableau:TColorStringGrid;
begin
  if OpenLex.Execute then
    begin
      Lexique.Sorted:=False;
      FichierLexique:=ExpandFileName(OpenLex.FileName);
      Lexique.LoadFromFile(FichierLexique);
      n:=-1;
      For i:=0 to Lexique.Count-1 do
        begin
          Lexique[i]:=Trim(Lexique[i]);
          if Lexique[i]='//MODIFS' then
            begin
              n:=i;
              Break;
            end;
        end;
      Modifs.Clear;
      if n>-1 then
        begin
          For i:=n+1 to Lexique.Count-1 do
            Modifs.Add(Lexique[i]);
          For i:=Lexique.Count-1 downto n do
            Lexique.Delete(i);
        end;
      Lexique.Sorted:=True;
      VerifieTrad(GridTaxons);
      ModifieTrad(GridTaxons);
      VerifieTrad(TabCat);
      ModifieTrad(TabCat);
      VerifieTrad(TabCarObs);
      ModifieTrad(TabCarObs);
      VerifieTrad(TabCarTab);
      ModifieTrad(TabCarTab);
      VerifieTrad(TabEtats);
      ModifieTrad(TabEtats);
      VerifieTrad(TabGroupes);
      ModifieTrad(TabGroupes);
      VerifieTrad(GridNomFicTax);
      ModifieTrad(GridNomFicTax);
    end;
end;
Function TTraduct_Col.CoupleTrad(Chaine:string):TCoupleTrad;
Var
  n:integer;
begin
  Result.ATraduire:='';
  Result.Traduction:='';
  n:=pos('=',Chaine);
  if n>0 then
    begin
      Result.ATraduire:=Trim(copy(Chaine,1,n-1));
      Result.Traduction:=Trim(copy(Chaine,n+1,Length(Chaine)));
    end;
end;
Function TTraduct_Col.TraductionDe(Liste:TStringList;Chaine:string):string;
Var
  i:integer;
  CTrad:TCoupleTrad;
  Ch:Char;
  Copie:string;
begin
  Result:='';
  For i:=0 to Liste.Count-1 do
    begin
      CTrad:=CoupleTrad(Liste[i]);
      Copie:=Trim(Chaine);
      if LowerCase(CTrad.ATraduire)=LowerCase(Copie) then
        begin
          Ch:=Copie[1];
          Result:=CTrad.Traduction;
          if (Ch >= 'A') and (Ch <= 'Z') then
            begin
              Ch:=Result[1];
              if (Ch >= 'a') and (Ch <= 'z') then
                Dec(Ch, 32);
              Result[1]:=Ch;
            end
          else if (Ch >= 'a') and (Ch <= 'z') then
            begin
              Ch:=Result[1];
              if (Ch >= 'A') and (Ch <= 'Z') then
                Inc(Ch, 32);
              Result[1]:=Ch;
            end;
          Break;
        end;
    end;
end;
Procedure TTraduct_Col.VerifieTrad(Tableau:TColorStringGrid);
Var
  i:integer;
  chaine,chaineT:string;
begin
  for i:=1 to Tableau.RowCount-1 do
    begin
      chaine:=Trim(Tableau.Cells[0,i]);
      chaineT:=TraductionDe(Lexique,Chaine);
      if ChaineT<>'' then
        begin
          if Tableau.Cells[1,i]='' then
            begin
             Tableau.Cells[1,i]:=ChaineT;
             Tableau.AffichCell[1,i]:=CaseJaune;
            end
          else if Trim(LowerCase(Tableau.Cells[1,i]))<>LowerCase(ChaineT) then
            begin
              if MessageDlg('Remplacer '+Tableau.Cells[1,i]+' par '+ChaineT+' ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
                begin
                  Tableau.Cells[1,i]:=ChaineT;
                  Tableau.AffichCell[1,i]:=CaseBlanche;
                end;
            end;
        end;
    end;
end;
Procedure TTraduct_Col.ModifieTrad(Tableau:TColorStringGrid);
Var
  i:integer;
  chaine,chaineT:string;
begin
  for i:=1 to Tableau.RowCount-1 do
    begin
      chaine:=Trim(Tableau.Cells[0,i]);
      chaineT:=TraductionDe(Modifs,Chaine);
      if ChaineT<>'' then
        begin
          if Tableau.Cells[1,i]='' then
            begin
             Tableau.Cells[1,i]:=ChaineT;
             Tableau.AffichCell[1,i]:=CaseJaune;
            end
          else if Trim(LowerCase(Tableau.Cells[1,i]))<>LowerCase(ChaineT) then
            begin
              if MessageDlg('Remplacer '+Tableau.Cells[1,i]+' par '+ChaineT+' ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
                begin
                  Tableau.Cells[1,i]:=ChaineT;
                  Tableau.AffichCell[1,i]:=CaseBlanche;
                end;
            end
        end
      else
        begin
          chaine:=Trim(Tableau.Cells[1,i]);
          if chaine<>'' then
            chaineT:=TraductionDe(Modifs,Chaine)
          else
            chaineT:='';
          if ChaineT<>'' then
            begin
              if Trim(LowerCase(Tableau.Cells[1,i]))<>LowerCase(ChaineT) then
                begin
                  if MessageDlg('Remplacer '+Tableau.Cells[1,i]+' par '+ChaineT+' ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
                    begin
                      Tableau.Cells[1,i]:=ChaineT;
                      Tableau.AffichCell[1,i]:=CaseBlanche;
                    end;
                end;
            end
        end;
    end;
end;
procedure TTraduct_Col.CompleteLexique(Tableau:TColorStringGrid);
Var
  i,n:integer;
  chaine,chaineT:string;
begin
  for i:=1 to Tableau.RowCount-1 do
    begin
      chaine:=Trim(Tableau.Cells[0,i]);
      chaineT:=TraductionDe(Modifs,Chaine);
      if ChaineT='' then
        begin
          if Tableau.Cells[1,i]<>'' then
            begin
              ChaineT:=Tableau.Cells[1,i];
              Lexique.Add(chaine+'='+ChaineT);
            end;
        end
      else if Trim(LowerCase(Tableau.Cells[1,i]))<>LowerCase(ChaineT) then
        begin
          if MessageDlg('Remplacer dans le lexique '+ChaineT+' par '+Tableau.Cells[1,i]+' ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
            begin
              Modifs.Add(ChaineT+'='+Tableau.Cells[1,i]);
              n:=IndiceDe(Chaine,Lexique);
              if n>-1 then
                Lexique[n]:=(Chaine+'='+Tableau.Cells[1,i]);
            end;
        end;
    end;
end;
procedure TTraduct_Col.EnregistreLexique;
Var
  Liste:TStringList;
begin
  Liste:=TStringList.Create;
  try
    Liste.Sorted:=False;
    CompleteLexique(GridTaxons);
    CompleteLexique(TabCat);
    CompleteLexique(TabCarObs);
    CompleteLexique(TabCarTab);
    CompleteLexique(TabEtats);
    CompleteLexique(TabGroupes);
    Liste.AddStrings(Lexique);
    if Modifs.Count>0 then
      begin
        Liste.Add('//MODIFS');
        Liste.AddStrings(Modifs);
      end;
    Liste.SaveToFile(FichierLexique);
  finally
    Liste.Free;
  end;
end;
function TTraduct_Col.IndiceDe(Chaine:string;Liste:TStringList):integer;
Var
  i:integer;
  CTrad:TCoupleTrad;
  Copie:string;
begin
  Result:=-1;
  For i:=0 to Liste.Count-1 do
    begin
      CTrad:=CoupleTrad(Liste[i]);
      if LowerCase(CTrad.ATraduire)=LowerCase(Chaine) then
        begin
          Result:=i;
          Break;
        end;
    end;
end;
end.
